@extends('layouts/template')

<!-- 頁面標題變數 -->
@section('title', trans("sidebar.pc.vnc"))

<!-- 頁面主要內容 -->
@section('container')
    <div class="page-header">
        <h1>{{ trans("sidebar.pc.main") }}
            <small>
                <i class="ace-icon fa fa-angle-double-right"></i>
                {{ trans("sidebar.pc.vnc") }}<!-- 繼承頁面設定 -->
            </small>
            <br />
        </h1>
    </div>
    <div class="row" id="grid-p">
        <ul class="nav nav-tabs">
            <li class="active"><a data-toggle="tab" href="#tab-a">{{trans('sidebar.pc.list')}}</a></li>
            @if(env('APP_REC',false))
                <li><a id="tb" data-toggle="tab" href="#tab-b">{{trans('pc.rec_list')}}</a></li>
            @endif
        </ul>
        <div class="tab-content">
            <div id="tab-a" class="tab-pane fade in active">
                <v-table ref="table"  :btn="{columns_bt:true,search_bt:true}" v-on:info="info" v-on:rec="rec" v-on:vnc="vnc"></v-table>
            </div>
            @if(env('APP_REC',false))
            <div id="tab-b" class="tab-pane fade">
                <v-table ref="rec" :local="rec_table" :btn="{columns_bt:true,search_bt:true}" v-on:stop="stop_rec"></v-table>
            </div>
            @endif
        </div>
    </div>
    <modal v-show="showModel" @close="showModel=false">
    <label style="font-size: 20px;" slot="header" v-text="modelTitle"></label>
    <div slot="body" style="margin: -12px;">
        <textarea style="width: 100%;max-width: 100%;" v-model="message"></textarea>
    </div>
    <div slot="footer">
        <button class="btn btn-success btn-sm pull-right" @click="send">{{trans('global.button.confirm')}}</button>
        <button class="btn btn-sm pull-right" style="margin-right: 10px;" @click="showModel=false">{{trans('global.button.cancel')}}</button>
        <br style="clear: both;">
    </div>
    </modal>
    <modal v-show="showModel2" @close="showModel2=false">
        <label style="font-size: 20px;" slot="header" v-text="text"></label>
        <div slot="body">
            <label>請輸入密碼 : </label>
            <input type="password" class="form-control" style="margin-bottom: 25px;" autocomplete="off" v-model="password">
        </div>
        <div slot="footer" style="margin-top: -20px;">
            @if(env("APP_VNC_ASK",false) == 1)
                <button class="btn btn-success btn-sm pull-right" @click="vnc_to('vnc viewer ask')">{{trans('global.button.view')}}</button>
                <button class="btn btn-warning btn-sm pull-right" style="margin-right: 10px;" @click="vnc_to('vnc connect ask')">{{trans('global.button.ctrl')}}</button>
            @elseif(env("APP_VNC_ASK",false) == 2)
                <button class="btn btn-success btn-sm pull-right" @click="vnc_to('vnc viewer ask2')">{{trans('global.button.view')}}</button>
                <button class="btn btn-warning btn-sm pull-right" style="margin-right: 10px;" @click="vnc_to('vnc connect ask2')">{{trans('global.button.ctrl')}}</button>
            @else
                <button class="btn btn-success btn-sm pull-right" @click="vnc_to('vnc viewer')">{{trans('global.button.view')}}</button>
                <button class="btn btn-warning btn-sm pull-right" style="margin-right: 10px;" @click="vnc_to('vnc connect')">{{trans('global.button.ctrl')}}</button>
           <!-- @endif-->
            <button class="btn btn-sm pull-right" style="margin-right: 10px;" @click="showModel2=false">{{trans('global.button.cancel')}}</button>
            <br style="clear: both;">
        </div>
    </modal>
@endsection

<!-- 頁面所需的 JS -->
@section('page_javascript')
    <script src="{{url('lodash.js')}}"></script>
    <script>
        $(document).ready(function () {
            window.vm = new Vue({
                el:'.main-content',
                data:{
                    modelTitle:'',
                    message:'',
                    to:'',
                    text:'',
                    row:{},
                    assetdata:{!!$assetdata!!},
                    showModel:false,
                    showModel2:false,
                    connected:false,
                    socket:null,
                    password: null,
                    hardwaredata:"",
                    table:{
                        columns:[
                            {name:'{{trans('pc.notify')}}',type:'button',id:'btn',align:'center',width:80,opt:[{type:'success',name:'',icon:'fa-bell',action:'info'}]},
                            {name:'{{trans('sidebar.pc.vnc')}}',type:'button',id:'btn',align:'center',width:80,opt:[{type:'info',name:'',icon:'fa-laptop',action:'vnc'}]},
                                @if(env('CUSTOMER', '') == 'fab')
                            {name:'{{trans('pc.assets_name')}}',id:'assets_name',width:80,sort:true,search:true},
                            {name:'{{trans('pc.assets_kind')}}',id:'assets_kind_id',width:100,sort:true,search:true,type:"option","opt":{!!$asset_kind !!}},
                            {name:'{{trans('pc.assets_location')}}',id:'assets_location_id',width:100,sort:true,search:true,type:"option","opt":{!!$asset_location !!}},
                            {name:'{{trans('pc.assets_place')}}',id:'assets_place_id',width:100,sort:true,search:true,type:"option","opt":{!!$asset_place !!}},
                            @foreach($custom as $item)
                            {!! json_encode($item) !!},
                                @endforeach
                                @endif
                            {name:'{{trans('sidebar.pc.group')}}',id:'group',type:'uri',width:150,sort:true,search:true},
                            {name:'{{trans('pc.pc_name')}}',id:'pc',type:'uri',width:150,sort:true,search:true},
                            {name:'IP',id:'ip',width:200,sort:true,search:true},
                            @if(env('APP_REC',false))
                            {name:'{{trans('pc.rec')}}',type:'button',id:'btn',align:'center',width:80,opt:[{type:'danger',name:'',icon:'fa-circle',action:'rec'}]},
                            @endif
                            //{name:'UUID',id:'uuid',sort:true,search:true},

                        ],
                        postData:{},
                        data: []
                    },
                    rec_table:{
                        columns:[
                            {name:'{{trans('sidebar.pc.group')}}',id:'group',type:'uri',width:300,sort:true,search:true},
                            {name:'{{trans('pc.pc_name')}}',id:'pc',type:'uri',width:300,sort:true,search:true},
                            {name:'IP',id:'ip',width:200,sort:true,search:true},
                            {name:'{{trans('global.label.created')}}',id:'time',type:'datetime',width:200,sort:true,search:true},
                            {name:'STOP',type:'button',id:'btn',align:'center',width:80,opt:[{type:'danger',name:'',icon:'fa-stop',action:'stop'}]}
                        ],
                        postData:{},
                        data: []
                    },
                },
                mounted: function () {
                    var self = this;
                    this.socket = io("http://{{env('APP_VNC','')}}:3000");

                    //測試用
                    this.socket.on('test', function (data) {
                        console.log(data);
                    });


                    this.socket.on('user joined', function (data) {
                        //console.log(data);
                        data.btn = " ";
                        self.table.data.push(data);
                        self.refresh();
                    });
                    this.socket.on('user left', function (data) {
                        for(var i in self.table.data){
                            if(self.table.data[i].socketid == data.socketid){
                                self.table.data.splice(i,1);
                                self.refresh();
                            }
                        }
                    });
                    this.socket.on('ark',function (data) {
                       
                        if(data.type === 1){
                          /**  var a = $('<a>').css({display:'none'}).attr('href','winnexus://{{env('APP_VNC','')}}/5900/123456');
                            $('body').append(a);
                            a.get(0).click();
                            a.remove();**/
						//	var a = $('<a>').css({display:'none'}).attr('href','control?path=?token='+vm.row.ip+':5800&view_only=true').attr('target','_blank');
							if(data.view.startsWith("vnc viewer")){
								var a = $('<a>').css({display:'none'}).attr('href','view?id='+data.id).attr('target','_blank');
							}else{
								var a = $('<a>').css({display:'none'}).attr('href','control?id='+data.id).attr('target','_blank');
							}
							$('body').append(a);
							a.get(0).click();
							a.remove();
							vm.showModel2 = false;
                        }else if(data.type === 2){
                            app.alert("等待對方回應");
                        }else if(data.type === 3){
                            app.alert("連線逾時");
                        }
                        vm.row.btn = ' ';
                        vm.refresh();
                    });
                    this.socket.on('task up', function (data) {
                        data.btn = " ";
                        vm.rec_table.data.push(data);
                        vm.refresh();
                    });
                    this.socket.on('task down', function (uuid) {
                        for(var i in vm.rec_table.data){
                            if(vm.rec_table.data[i].uuid === uuid){
                                app.alert(vm.rec_table.data[i].pc+" 錄影已終止");
                                vm.rec_table.data.splice(i, 1);
                                break;
                            }
                        }
                        vm.refresh();
                    });
                    this.socket.on('data change',function (data) {
                        data.btn = " ";
                        for(var i in self.table.data){
                            if(self.table.data[i].socketid == data.socketid){
                                self.table.data[i] = data;
                                self.refresh();
                            }
                        }
                    });
                    this.socket.on('connect', function(){
                        if(!self.connected){
                            self.connected = true;
                            self.login();
                            console.log("connect");
                        }
                    });
                    this.socket.on('disconnect', function () {
                        self.connected = false;
                        self.table.data = [];
                        self.refresh();
                        console.log("disconnect");
                    });
                },
                methods:{
                    info:function (row) {
                        this.message = "";
                        this.to = row.socketid;
                        this.modelTitle = row.pc;
                        this.showModel = true;
                    },
                    send:function () {
                        this.socket.emit('new message',{id:this.to,msg: this.message});
                        this.showModel = false;
                    },
                    vnc_to:function (type) {
                        if (this.password === null) {
                            alert('請輸入密碼');
                            vm.refresh();
                            vm.showModel2 = false;
                        } else {
                            $.ajax({
                                url: '/pc/vncpassword/',
                                type: 'POST',
                                data: {
                                    password: this.password
                                },
                                success: function (data) {
									vm.socket.emit('new message',{id:vm.row.socketid,msg: type});
									vm.row.btn = 'disabled';
									vm.password = '';
									vm.refresh();
									return;
                                   /** if(vm.row.ip.startsWith("::")){
										vm.socket.emit('new message',{id:vm.row.socketid,msg: type});
										vm.row.btn = 'disabled';
										vm.password = '';
										vm.refresh();
										return;
									}
									var a = null;
									if(type.startsWith("vnc viewer")){
										a = $('<a>').css({display:'none'}).attr('href','view?id='+vm.row.socketid).attr('target','_blank');view
									}else{
										a = $('<a>').css({display:'none'}).attr('href','control?id='+vm.row.socketid).attr('target','_blank');
									}
								    $('body').append(a);
									a.get(0).click();
									a.remove();
									vm.showModel2 = false;	
								  **/
                                },
                                error: function (jqXHR, textStatus, errorThrown) {
                                    console.error(jqXHR);
                                    console.error(textStatus);
                                    console.error(errorThrown);
                                    vm.password = '';
                                    alert('密碼錯誤！');
                                    vm.refresh();
                                    vm.showModel2 = false;
                                }
                            });
                        }
                        //vm.socket.emit('new message',{id:vm.row.id,msg: type});
                        //vm.row.btn = 'disabled';
                        //vm.refresh();
                        //vm.showModel2 = false;
                    },
                    rec:function (row) {
                        app.confirm("您確定要對電腦 ( "+row.pc+" ) 進行錄製？",function (flag) {
                            if(flag){
                                vm.socket.emit('new message',{id:row.socketid,msg: 'vnc rec'});
                                $("#tb").click();
                            }
                        });
                    },
                    stop_rec:function (row) {
                        vm.socket.emit('new message',{id:row.socketid,msg: 'stop rec'});
                    },
                    vnc:function (row) {
                        this.text = "您確定要連線到"+row.ip+' ('+row.pc+') ?';
                        this.row = row;
                        this.showModel2 = true;
                    },
                    refresh:function () {
                        this.$refs.table.refresh();
                        if(this.$refs.rec){
                            this.$refs.rec.refresh();
                        }
                    },
                    assets:function (pcname) {
                        var result ;
                        $.ajax({
                            url : '/pc/asset',
                            type : "get",
                            data : {
                                pcname:pcname,
                                mode:'0'
                            },
                            async : false,
                            success : function(data) {
                                result = data;
                            }
                        });
                        return result;

                    },
                    hardware:function (pcname) {
                        var result ;
                        $.ajax({
                            url : '/pc/asset',
                            type : "get",
                            data : {
                                pcname:pcname,
                                mode:'1'
                            },
                            async : false,
                            success : function(data) {
                                result = data;
                            }
                        });
                        return result;

                    },
                    login:function () {
                        var self = this;
                        this.socket.emit('login',{token:'{{$token}}'}, function(data){
                            if(data.status == 1){
                               // self.table.data = data.list;
								
                                self.rec_table.data = data.task;

                               /** for(var i=0;i<self.table.data.length;i++){
                                    var result= _.findIndex(self.assetdata, function(o) { return o.mac == self.table.data[i].uuid; });
                                    if(result!==-1){
                                        self.table.data[i].assets_kind_id =self.assetdata[result].assets_kind_id;
                                        self.table.data[i].assets_name =self.assetdata[result].assets_name;
                                        self.table.data[i].assets_location_id =self.assetdata[result].assets_location_id;
                                        self.table.data[i].assets_place_id =self.assetdata[result].assets_place_id;
                                        self.table.data[i].assets_custom01 =self.assetdata[result].assets_custom01;
                                    }
                                }
                                for(var i=0;i<self.table.data.length;i++){
                                    self.table.data[i].btn = " ";
                                }
                                console.log(self.table.data);**/
                                for(var i=0;i<self.rec_table.data.length;i++){
                                    self.rec_table.data[i].btn = " ";
                                }
                                self.refresh();
                            }else if(data.status == 2){
                                app.alert('token已失效，請嘗試 F5 刷新頁面');
                            }
                        });
                    }

                }
            });
        });
    </script>
@endsection